#include <bits/stdc++.h>

using namespace std;

int a[1000001],b[1000001];


int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);


    int n;

    cin >> n;



    int prethodni = -100;

    bool jeste = false;

    for(int i = 0 ; i < n ; i++)
    {
        cin >> a[i];

        b[i] = a[i];



        if(prethodni == a[i])
        {
            jeste = true;

        }
            prethodni = a[i];

    }



    sort(a,a+n,greater<>());


    int index = -1;

    int broj;

    for(int i = 0 ; i < n ; i++)
    {
        if(a[i] != b[i])
        {
            index = i;

            broj = a[i];
            break;

        }
    }


    if(index != -1)
    {

        for(int i = n-1 ; i >= 0; i--)
        {
            if(broj == b[i])
            {
                swap(b[i],b[index]);
            }
        }

    }
    else if(!jeste)
    {
        swap(b[n-1],b[n-2]);


    }

    for(int i = 0 ; i < n ; i++)
        cout << b[i] << " ";



    return 0;
}